package org.spagic.sap.bapi;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.sap.conn.jco.JCoFunction;
import com.sap.conn.jco.JCoMetaData;

public class BAPIParameter {
	
	private SimpleDateFormat sapJCODateFormat = new SimpleDateFormat("yyyyMMdd"); 
	private SimpleDateFormat sapJCOTimeFormat = new SimpleDateFormat("HH:mm:ss");
	
	private String name = null;
	private String xpath = null;
	
	public BAPIParameter(String name, String xpath) {
		super();
		this.name = name;
		this.xpath = xpath;
	}

	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	

	public String getXpath() {
		return xpath;
	}

	public void setXpath(String xpath) {
		this.xpath = xpath;
	}
	
	public void setValueOnFunction(JCoFunction jcoFunction, JCoMetaData inputParametersMetadata, String stringValue) throws Exception {
		
		String className = inputParametersMetadata.getClassNameOfField(name);
		if (className.equalsIgnoreCase(String.class.getName())){
			jcoFunction.getImportParameterList().setValue(name, stringValue);
		}else if (className.equalsIgnoreCase(BigDecimal.class.getName())){
			BigDecimal bdValue = new BigDecimal(stringValue);
			jcoFunction.getImportParameterList().setValue(name, bdValue);
		}else if (className.equalsIgnoreCase(Date.class.getName())){
			Date dateValue = null;
			if (inputParametersMetadata.getType(name) == JCoMetaData.TYPE_DATE){
				dateValue = sapJCODateFormat.parse(stringValue);
			}else if (inputParametersMetadata.getType(name) == JCoMetaData.TYPE_TIME){
				dateValue = sapJCOTimeFormat.parse(stringValue);
			}
			jcoFunction.getImportParameterList().setValue(name, dateValue);
		}else if (className.equalsIgnoreCase(Integer.class.getName())){
			int intValue = Integer.valueOf(stringValue).intValue();
			jcoFunction.getImportParameterList().setValue(name, intValue);
		}
	}
	
	
	
}
